Cowboy User Guide
=================

The Cowboy User Guide explores the modern Web and how to make
best use of Cowboy for writing powerful web applications.

Introducing Cowboy
------------------

 *  [Introduction](introduction.md)
 *  [The modern Web](modern_web.md)
 *  [Erlang and the Web](erlang_web.md)
 *  [Erlang for beginners](erlang_beginners.md)
 *  [Getting started](getting_started.md)

HTTP
----

 *  [The life of a request](http_req_life.md)
 *  [Routing](routing.md)
 *  [Handling plain HTTP requests](http_handlers.md)
 *  [The Req object](req.md)
 *  [Reading the request body](req_body.md)
 *  [Sending a response](resp.md)
 *  [Using cookies](cookies.md)

Multipart
---------

 *  [Introduction to multipart](multipart_intro.md)
 *  [Multipart requests](multipart_req.md)

Static files
------------

 *  [Static handler](static_handlers.md)

REST
----

 *  [REST principles](rest_principles.md)
 *  [Handling REST requests](rest_handlers.md)
 *  [REST flowcharts](rest_flowcharts.md)

Websocket
---------

 *  [The Websocket protocol](ws_protocol.md)
 *  [Handling Websocket connections](ws_handlers.md)

Server push
-----------

 *  [Loop handlers](loop_handlers.md)

Pluggable interface
-------------------

 *  [Middlewares](middlewares.md)
 *  [Protocol upgrades](upgrade_protocol.md)
 *  [Hooks](hooks.md)

Internals
---------

 *  [Architecture](architecture.md)
 *  [Dealing with broken clients](broken_clients.md)
